package com.yc.ship.module.ota.service.tradelog;

import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.ota.controller.admin.tradelog.vo.TradeLogPageReqVO;
import com.yc.ship.module.ota.controller.admin.tradelog.vo.TradeLogSaveReqVO;
import com.yc.ship.module.ota.dal.dataobject.tradelog.TradeLogDO;

import javax.validation.Valid;
import java.math.BigDecimal;

/**
 * 分销商交易日志 Service 接口
 *
 * @author 管理员
 */
public interface TradeLogService {

    /**
     * 创建分销商交易日志
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createTradeLog(@Valid TradeLogSaveReqVO createReqVO);

    /**
     * 更新分销商交易日志
     *
     * @param updateReqVO 更新信息
     */
    void updateTradeLog(@Valid TradeLogSaveReqVO updateReqVO);

    /**
     * 删除分销商交易日志
     *
     * @param id 编号
     */
    void deleteTradeLog(Long id);

    /**
     * 获得分销商交易日志
     *
     * @param id 编号
     * @return 分销商交易日志
     */
    TradeLogDO getTradeLog(Long id);

    /**
     * 获得分销商交易日志分页
     *
     * @param pageReqVO 分页查询
     * @return 分销商交易日志分页
     */
    PageResult<TradeLogDO> getTradeLogPage(TradeLogPageReqVO pageReqVO);

    Long saveTradeLog(TradeLogDO tradeLogDO);

    Long distributorRecharge(Long id, Long selfRechargeId, Integer type, Long userId, String userName, BigDecimal money);
}
